// zelea2 - June 2013
// Unlock Acer Cloudmobile phones (all variants)

char         *hdr = "ANDROID-BOOT!";
void         *search;
void         *part_hdr;
int           counter;

int           ( *display_printf ) ( char *, unsigned );	// entry for printf
							// function
void          ( *write_aboot ) ( char * );	// commit to partition table

int
strcmp( const char *s1, const char *s2 )
{
  while ( *s1 && *s1 == *s2 )
    s1++, s2++;
  return ( *s1 - *s2 );
}

void
unlock_acer_cloudmobile( void )
{
  part_hdr = 0;
  for ( search = ( void * ) 0x88F30000; search < ( void * ) 0x88F48000;
      search += 4 )
  {
    if ( strcmp( search, hdr ) == 0
	&& *( unsigned * ) ( search + 0x24 ) == 0x20342FF )
    {
      part_hdr = search;
      break;
    }
  }
  if ( !part_hdr )		// failed to find partition header
    return;

  // now find some functions
  display_printf = 0;
  for ( search = ( void * ) 0x88F00000; search < ( void * ) 0x88F30000;
      search += 4 )
  {
    if ( ( ( *( unsigned * ) search & 0xfffffe00 ) == 0xf44fb400 ) &&	
	( ( *( unsigned * ) ( search + 4 ) & 0xfe00ffff ) == 0xb4007180 ) )
    {
      display_printf = ( void * ) ( search + 1 );	// thumb function
      break;
    }
  }
  if ( !display_printf )	// failed to find printf function
    return;
  ( *display_printf ) ( "'printf' found at address %x\n",
      ( unsigned ) display_printf );

  write_aboot = 0;
  for ( search = ( void * ) 0x88F00000; search < ( void * ) 0x88F30000;
      search += 4 )
  {
    if(	( *( unsigned * ) ( search + 4 ) == 0x70fff6cf ) &&  // MOV R0, 0xFFFFFE00
	( *( unsigned * ) ( search + 8 ) == 0x31fff04f ) )   // MOV.W R1, #0xFFFFFFF 
    {
      // now go backwards to find the subroutine start
      counter = 0;
      while ( 1 )
      {
	search -= 4;
	counter++;
	if ( counter > 100 || search <= ( void * ) 0x88F00000 )
	  return;
	if ( ( *( unsigned * ) search & 0xffff ) == 0xe92d )	// PUSH.W {}
	  break;
      }
      write_aboot = ( void * ) ( search + 1 );	// thumb function
      break;
    }
  }
  if ( !write_aboot )		// failed to find write_aboot function
    return;
  ( *display_printf ) ( "'write_aboot' found at address %x\n\n",
      ( unsigned ) write_aboot );
  ( *display_printf ) ( "Unlocked: %d\n", ((unsigned *)part_hdr)[4] );
  ( *display_printf ) ( "Tampered: %d\n", ((unsigned *)part_hdr)[5] );
  ( *display_printf ) ( "Reset Counter: %d\n", ((unsigned *)part_hdr)[6] );
  if( ((unsigned *)part_hdr)[4] )
    ( *display_printf ) ( "\nYour phone is already unlocked\n", 0 );
  else
  {
#if 1
    ((unsigned *)part_hdr)[4] = 1;	// mark unlocked
    ( *write_aboot ) ( part_hdr );
#else
    ( *display_printf ) ( "\nYour phone appears to be ready to be unlocked\n", 0 );
#endif
  }
  ( *display_printf ) ( "\nDone\nPlease remove the battery and power cycle the phone\n", 0 );
}
